startover:
DECLARE LIBRARY "WindowsAPI"
    FUNCTION Window_GetHandle& (WindowTitle$)
    FUNCTION Window_Minimise (WindowTitle$)
    FUNCTION Window_Restore (WindowTitle$)
    FUNCTION Window_Set_Title& (CurrentTitle$, NewTitle$)
    FUNCTION Window_Get_ProcessID& (WindowTitle$)
    SUB Window_Set_XY (WindowTitle$, BYVAL X&, BYVAL Y&)
END DECLARE

_TITLE "SHUFFLE!"

CLEAR

DEFINT A-Z
RANDOMIZE TIMER

DIM xcounter(15, 15), ycounter(15, 15)
DIM bg(900000), fg(900000)
DIM SHARED frame, picfile$, file$, changepic, click, rightclick
DIM SHARED playermoves

playermoves = 0
file$ = "shuffle.ini"
IF Exist%(file$) THEN
    OPEN file$ FOR INPUT AS #1
    INPUT #1, frame, picfile$
    CLOSE #1
ELSE
    frame = 0
    picfile$ = "pictures\default.jpg"
END IF

CALL titlescreen
DO
    CALL clicker

    IF click = 1 THEN
        ' if button clicked, check where it was clicked at
        IF _MOUSEX > 25 AND _MOUSEY > 610 AND _MOUSEX < 125 AND mousey < 710 THEN CALL helpfile
        IF _MOUSEY > 645 AND _MOUSEY < 685 THEN
            'clicked in the difficulty row, need to check for which column was clicked
            SELECT CASE _MOUSEX
                CASE 150 TO 295: z = 8
                CASE 300 TO 445: z = 4
                CASE 450 TO 595: z = 2
                CASE 600 TO 745: z = 1
            END SELECT
        END IF
        IF _MOUSEX > 850 AND _MOUSEX < 1000 THEN
            'clicked in the options column, need to see if correct row was accessed
            IF _MOUSEY > 620 AND _MOUSEY < 660 THEN CALL options
            IF _MOUSEY > 670 AND _MOUSEY < 710 THEN SYSTEM
            'LOCATE 31, 1: PRINT _MOUSEX, _MOUSEY, _MOUSEBUTTON(1)
        END IF
    END IF
    a$ = INKEY$
    IF a$ = CHR$(27) OR rightclick = 1 THEN CALL quitbox
LOOP UNTIL z <> 0

CLS
SCREEN _NEWIMAGE(1280, 720, 32)
_PUTIMAGE (0, 0)-(1280, 720), _LOADIMAGE(picfile$, 32)
IF frame = 1 THEN
    LINE (0, 0)-(1280, 719), _RGB(255, 255, 255), B
    LINE (1, 1)-(1279, 718), _RGB(255, 255, 255), B
    LINE (2, 2)-(1278, 717), _RGB(255, 255, 255), B
END IF

starttime! = TIMER
FOR X = 0 TO (16 / z) - 1
    FOR y = 0 TO (16 / z) - 1
        LINE (X * 80 * z, y * 45 * z)-(X * 80 * z + 80 * z - 1, y * 45 * z + 45 * z - 1), _RGB(0, 0, 0), B
    NEXT
NEXT

FOR X = 0 TO (16 / z) - 1
    FOR y = 0 TO (16 / z) - 1
        xcounter(X, y) = X
        ycounter(X, y) = y
    NEXT
NEXT

FOR X = 0 TO (16 / z) - 1
    FOR y = 0 TO (16 / z) - 1
        xswap = INT(RND(1) * (16 / z - 1) + 0.5)
        yswap = INT(RND(1) * (16 / z - 1) + 0.5)
        IF xswap < 0 THEN xswap = 0: IF yswap < 0 THEN yswap = 0
        IF xswap > (16 / z - 1) THEN xswap = INT(16 / z - 1): IF yswap > (16 / z - 1) THEN yswap = INT(16 / z - 1)
        tempx = xcounter(X, y): tempy = ycounter(X, y)
        xcounter(X, y) = xcounter(xswap, yswap): ycounter(X, y) = ycounter(xswap, yswap)
        xcounter(xswap, yswap) = tempx: ycounter(xswap, yswap) = tempy
        GET (X * 80 * z, y * 45 * z)-(X * 80 * z + 80 * z - 1, y * 45 * z + 45 * z - 1), bg()
        GET (xswap * 80 * z, yswap * 45 * z)-(xswap * 80 * z + 80 * z - 1, yswap * 45 * z + 45 * z - 1), fg()
        PUT (X * 80 * z, y * 45 * z), fg(), PSET
        PUT (xswap * 80 * z, yswap * 45 * z), bg(), PSET
    NEXT
NEXT

firstclick = 0
'buttondown = 0
DO
    won = 1
    CALL clicker
    IF click = 1 THEN
        X = INT(_MOUSEX / 80 / z): y = INT(_MOUSEY / 45 / z)
        IF X < 0 THEN X = 0: IF X > (16 / z - 1) THEN X = (16 / z - 1)
        IF y < 0 THEN y = 0: IF y > (16 / z - 1) THEN y = (16 / z - 1)
        LINE (X * 80 * z, y * 45 * z)-(X * 80 * z + 80 * z - 1, y * 45 * z + 45 * z - 1), _RGB(255, 0, 0), B
        click = 0: buttondown = 0 'reset where needed
        IF firstclick = 0 THEN 'click on 1st picture
            tempx = X: tempy = y
            tempx1 = xcounter(X, y): tempy1 = ycounter(X, y)
            firstclick = 1
        ELSE 'click on second picture and swap them
            playermoves = playermoves + 1 ' Keeps tracks of how many moves the player makes
            xcounter(tempx, tempy) = xcounter(X, y): ycounter(tempx, tempy) = ycounter(X, y)
            xcounter(X, y) = tempx1: ycounter(X, y) = tempy1
            GET (X * 80 * z, y * 45 * z)-(X * 80 * z + 80 * z - 1, y * 45 * z + 45 * z - 1), bg()
            GET (tempx * 80 * z, tempy * 45 * z)-(tempx * 80 * z + 80 * z - 1, tempy * 45 * z + 45 * z - 1), fg()
            PUT (X * 80 * z, y * 45 * z), fg(), PSET
            PUT (tempx * 80 * z, tempy * 45 * z), bg(), PSET
            LINE (X * 80 * z, y * 45 * z)-(X * 80 * z + 80 * z - 1, y * 45 * z + 45 * z - 1), _RGB(0, 0, 0), B
            LINE (tempx * 80 * z, tempy * 45 * z)-(tempx * 80 * z + 80 * z - 1, tempy * 45 * z + 45 * z - 1), _RGB(0, 0, 0), B
            firstclick = 0
        END IF
    END IF

    FOR a = 0 TO 16 / z - 1
        FOR b = 0 TO 16 / z - 1
            IF xcounter(a, b) <> a OR ycounter(a, b) <> b THEN won = 0 'Check to see if the picture is correct
        NEXT
    NEXT

    a$ = INKEY$

    IF a$ = CHR$(32) OR rightclick THEN
        'perform statuscheck
        numright = 0
        FOR a = 0 TO 16 / z - 1
            FOR b = 0 TO 16 / z - 1
                IF xcounter(a, b) = a AND ycounter(a, b) = b THEN numright = numright + 1 'Check to see how many pieces are correct
            NEXT
        NEXT
        CALL statuscheck(playermoves, starttime!, z, numright)
    END IF
    IF a$ = CHR$(27) THEN CALL quitbox
LOOP UNTIL won = 1



IF starttime! < TIMER THEN
    'life is good, you didn't play past midnight
    finishtime! = TIMER - starttime!
ELSE
    'you started before midnight and played until after midnight
    finishtime! = 60 * 60 * 24 - starttime! + TIMER
END IF

CALL youwon(z, finishtime!)


GOTO startover

END

SUB titlescreen
SCREEN _NEWIMAGE(1280, 720, 32)
CLS
_PUTIMAGE (0, 0)-(1280, 600), _LOADIMAGE(picfile$, 32)
_FONT _LOADFONT("C:\windows\fonts\cour.ttf", 20)
IF frame = 1 THEN
    LINE (0, 0)-(1280, 600), _RGB(255, 255, 255), B
    LINE (1, 1)-(1279, 599), _RGB(255, 255, 255), B
    LINE (2, 2)-(1278, 598), _RGB(255, 255, 255), B
END IF

LOCATE 31, 1
COLOR _RGB(256, 256, 100)
PRINT "                       Study the above picture VERY carefully"
PRINT "                    Then choose your Shuffle difficulty to begin"
CALL button(25, 610, 125, 710, "", 255, 255, 255, 10)
CALL button(150, 645, 295, 685, "<  TRIVIAL >", 255, 255, 0, 10)
CALL button(300, 645, 445, 685, "<<  EASY  >>", 255, 255, 0, 10)
CALL button(450, 645, 595, 685, "<<  HARD  >>", 255, 255, 0, 10)
CALL button(600, 645, 745, 685, "<< INSANE >>", 255, 255, 0, 10)
CALL button(850, 620, 1000, 660, "<  OPTIONS >", 0, 255, 255, 10)
CALL button(850, 670, 1000, 710, "<<  QUIT  >>", 255, 0, 0, 10)
CALL button(1050, 620, 1260, 710, "", 0, 0, 0, 10)
_FONT _LOADFONT("C:\windows\fonts\cour.ttf", 13)
COLOR _RGB(255, 0, 0)
_PRINTSTRING (1055, 625), " WRITTEN AND DESIGNED BY "
COLOR _RGB(255, 255, 0)
_FONT _LOADFONT("C:\windows\fonts\cour.ttf", 16, "BOLD")
_PRINTSTRING (1055, 638), "  Steven D McNeill "
_PRINTSTRING (1055, 653), " 230 McNeil Hill Rd"
_PRINTSTRING (1055, 668), "  Pilot  VA  24138 "
COLOR _RGB(255, 0, 0)
_FONT _LOADFONT("C:\windows\fonts\cour.ttf", 13)
_PRINTSTRING (1055, 685), "If you like this, send $$"
_PRINTSTRING (1055, 695), "  Keep Shareware alive!  "
_FONT _LOADFONT("C:\windows\fonts\cour.ttf", 120)
COLOR _RGB(255, 0, 0)
_PRINTMODE _KEEPBACKGROUND
_PRINTSTRING (40, 590), "?"
_FONT _LOADFONT("C:\windows\fonts\cour.ttf", 20, "BOLD")
_PRINTSTRING (50, 685), "HELP"
_PRINTMODE _FILLBACKGROUND
END SUB


SUB button (x1, y1, x2, y2, a$, c1, c2, c3, offset)
IF offset < 5 THEN offset = 5
LINE (x1, y1)-(x2, y2), _RGB(256, 256, 256), B
LINE (x1 + 1, y1 + 1)-(x2 - 1, y2 - 1), _RGB(0, 0, 0), B
LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), _RGB(0, 0, 0), B
LINE (x1 + 3, y1 + 3)-(x2 - 3, y2 - 3), _RGB(0, 0, 0), B
LINE (x1, y1)-(x1 + 3, y1 + 3), _RGB(256, 256, 256)
LINE (x2, y1)-(x2 - 3, y1 + 3), _RGB(256, 256, 256)
LINE (x1, y2)-(x1 + 3, y2 - 3), _RGB(256, 256, 256)
LINE (x2, y2)-(x2 - 3, y2 - 3), _RGB(256, 256, 256)
LINE (x1 + 3, y1 + 3)-(x2 - 3, y2 - 3), _RGB(c1, c2, c3), BF
COLOR _RGB(0, 0, 0)
_PRINTMODE _KEEPBACKGROUND
_PRINTSTRING (x1 + offset, y1 + offset), a$
COLOR _RGB(c1, c2, c3)
_PRINTMODE _FILLBACKGROUND
END SUB




SUB options
DIM bg(900000)
GET (440, 210)-(840, 510), bg() ' get the background under the option screen
CALL button(440, 210, 840, 510, "", 0, 255, 255, 10)
CALL button(528, 220, 728, 250, "     RETURN     ", 255, 0, 255, 6)
CALL button(528, 260, 728, 290, "    LANGUAGE    ", 255, 255, 0, 6)
CALL button(528, 300, 728, 330, " CHOOSE PICTURE ", 255, 255, 0, 6)
CALL button(528, 340, 728, 370, "   HIGH SCORE   ", 255, 255, 0, 6)
IF frame = 0 THEN
    CALL button(528, 380, 728, 410, "    FRAME ON    ", 255, 255, 0, 6)
ELSE
    CALL button(528, 380, 728, 410, "    FRAME OFF   ", 255, 255, 0, 6)
END IF
CALL button(528, 460, 728, 490, "      QUIT     ", 255, 0, 0, 6)
DO
    changepic = 0
    CALL clicker
    IF click = 1 THEN 'left mouse button must be pressed to check where it was pushed at
        IF _MOUSEX > 528 AND _MOUSEX < 728 THEN 'mouse must be in the correct left-right area
            IF _MOUSEY > 220 AND _MOUSEY < 250 THEN EXIT DO
            IF _MOUSEY > 260 AND _MOUSEY < 290 THEN CALL language: EXIT DO
            IF _MOUSEY > 380 AND _MOUSEY < 410 THEN CALL framer: EXIT DO
            IF _MOUSEY > 300 AND _MOUSEY < 330 THEN CALL choosepic: click = 0: EXIT DO 'reset click counter so that if the picture chosen was in the right area, the next quit option won't trigger
            IF _MOUSEY > 340 AND _MOUSEY < 370 THEN CALL highscores: EXIT DO
            IF _MOUSEY > 460 AND _MOUSEY < 490 AND click = 1 THEN CALL quitbox
        ELSE
            click = 0: rightclick = 0 'was clicked in wrong area
        END IF
    END IF
    a$ = INKEY$
    IF a$ = CHR$(27) OR rightclick THEN EXIT DO
LOOP
IF changepic = 1 THEN
    CALL titlescreen
    GET (440, 210)-(840, 510), bg() ' get the new background under the option screen
END IF
click = 0: rightclick = 0
PUT (440, 210), bg(), PSET 'restore the background behind the options
END SUB


SUB language
DIM fg(900000)
GET (440, 210)-(840, 510), fg()
CALL button(440, 210, 840, 510, "", 0, 255, 0, 10)
CALL button(528, 220, 728, 250, "     RETURN     ", 255, 0, 255, 6)
CALL button(528, 260, 728, 290, "  U.S. ENGLISH  ", 255, 255, 0, 6)
CALL button(528, 300, 728, 330, "  CANADIAN ENG. ", 255, 255, 0, 6)
CALL button(528, 340, 728, 370, "  U.K. ENGLISH  ", 255, 255, 0, 6)
CALL button(528, 380, 728, 410, "   AUSTRALIAN   ", 255, 255, 0, 6)
CALL button(528, 460, 728, 490, "      QUIT     ", 255, 0, 0, 6)
DO
    CALL clicker
    IF click = 1 THEN 'left mouse button must be pressed to check where it was pushed at
        click = 0 'reset clicker
        IF _MOUSEX > 528 AND _MOUSEX < 728 THEN 'mouse must be in the correct left-right area
            IF _MOUSEY > 220 AND _MOUSEY < 250 THEN EXIT DO
            IF _MOUSEY > 260 AND _MOUSEY < 290 THEN EXIT DO
            IF _MOUSEY > 300 AND _MOUSEY < 330 THEN EXIT DO
            IF _MOUSEY > 340 AND _MOUSEY < 370 THEN EXIT DO
            IF _MOUSEY > 380 AND _MOUSEY < 410 THEN EXIT DO
            IF _MOUSEY > 460 AND _MOUSEY < 490 THEN CALL quitbox
        END IF
    END IF

    a$ = INKEY$
    IF a$ = CHR$(27) OR rightclick THEN EXIT DO
LOOP
PUT (440, 210), fg(), PSET
END SUB




SUB framer
IF frame = 0 THEN
    frame = 1
    LINE (0, 0)-(1280, 600), _RGB(255, 255, 255), B
    LINE (1, 1)-(1279, 599), _RGB(255, 255, 255), B
    LINE (2, 2)-(1278, 598), _RGB(255, 255, 255), B
ELSE
    frame = 0
    LINE (0, 0)-(1280, 600), _RGB(0, 0, 0), B
    LINE (1, 1)-(1279, 599), _RGB(0, 0, 0), B
    LINE (2, 2)-(1278, 598), _RGB(0, 0, 0), B
END IF
OPEN "shuffle.ini" FOR OUTPUT AS #1
PRINT #1, frame, picfile$
CLOSE #1
END SUB




SUB choosepic
DIM ig(900000), pic$(9), pictrue(9)
DIM x1(9), y1(9), x2(9), y2(9)
GET (428, 200)-(852, 530), ig()
CALL button(428, 200, 852, 530, "", 0, 0, 0, 10)
SHELL _HIDE "dir pictures>photolist.dat /a-d /b"
OPEN "photolist.dat" FOR INPUT AS #1
DO
    picturecount = picturecount + 1
    LINE INPUT #1, junk$
LOOP WHILE NOT EOF(1)
CLOSE
picmin = 1: picmax = 9: picon = 0: picchange = -1
goahead = -1
FOR i = 1 TO 9 'set x,y coordinates for where the preview pictures will be placed
    SELECT CASE i
        CASE 1, 2, 3: y1(i) = 220: y2(i) = 310
        CASE 4, 5, 6: y1(i) = 320: y2(i) = 410
        CASE 7, 8, 9: y1(i) = 420: y2(i) = 510
    END SELECT
    SELECT CASE i
        CASE 1, 4, 7: x1(i) = 438: x2(i) = 558
        CASE 2, 5, 8: x1(i) = 568: x2(i) = 678
        CASE 3, 6, 9: x1(i) = 688: x2(i) = 798
    END SELECT
NEXT
DO
    IF picchange THEN
        FOR i = 1 TO 9: pictrue(i) = 0: NEXT 'Pictures are NOT valid by default
        CALL button(428, 200, 852, 530, "", 0, 0, 0, 10)
        CALL button(818, 270, 838, 460, "", 255, 0, 0, 2)
        COLOR _RGB(255, 255, 0)
        _PRINTMODE _KEEPBACKGROUND
        _FONT _LOADFONT("C:\windows\fonts\cour.ttf", 20, "BOLD")
        y3 = 273
        _PRINTSTRING (822, y3), "K"
        _PRINTSTRING (822, y3 + 15), "E"
        _PRINTSTRING (822, y3 + 30), "E"
        _PRINTSTRING (822, y3 + 45), "P"
        _PRINTSTRING (822, y3 + 60), " "
        _PRINTSTRING (822, y3 + 75), "C"
        _PRINTSTRING (822, y3 + 90), "U"
        _PRINTSTRING (822, y3 + 105), "R"
        _PRINTSTRING (822, y3 + 120), "R "
        _PRINTSTRING (822, y3 + 135), "E"
        _PRINTSTRING (822, y3 + 150), "N"
        _PRINTSTRING (822, y3 + 165), "T"
        _PRINTSTRING (822, y3 + 180), " "
        _FONT _LOADFONT("C:\windows\fonts\cour.ttf", 14, "BOLD")
        _PRINTSTRING (440, 203), "   CLICK ON PICTURE PREVIEW TO CHANGE"
        _PRINTSTRING (440, 513), "     UP/DOWN ARROW FOR MORE CHOICES"
        _PRINTMODE _FILLBACKGROUND
        picchange = 0
        OPEN "photolist.dat" FOR INPUT AS #1
        IF picon > 0 THEN 'load junk pictures to increase file counter if on a page other than the first
            FOR i = 1 TO picon: LINE INPUT #1, junk$: NEXT
        END IF
        picmin = 1: picmax = picturecount - picon
        IF picmax <= 0 THEN picmax = 9
        IF picmax > 9 THEN picmax = 9
        FOR i = picmin TO picmax
            pictrue(i) = -1 'Make picture valid if they exist in the lineup
            LINE INPUT #1, pic$(i)
            pic$(i) = "pictures\" + pic$(i)
            _PUTIMAGE (x1(i), y1(i))-(x2(i), y2(i)), _LOADIMAGE(pic$(i), 32)
            LINE (x1(i), y1(i))-(x2(i), y2(i)), _RGB(255, 255, 255), B
            uptrue = 0: downtrue = 0
            IF picon > 0 THEN
                uptrue = -1
                CALL button(818, 210, 838, 260, "", 255, 0, 0, 2)
                COLOR _RGB(255, 255, 0)
                _PRINTMODE _KEEPBACKGROUND
                _FONT _LOADFONT("C:\windows\fonts\cour.ttf", 65)
                LOCATE 4, 813: PRINT CHR$(24)
                _FONT _LOADFONT("C:\windows\fonts\cour.ttf", 14)
                _PRINTMODE _FILLBACKGROUND
                'handle up button
            END IF
            IF picon + 9 < picturecount THEN
                downtrue = -1
                CALL button(818, 470, 838, 520, "", 255, 0, 0, 2)
                COLOR _RGB(255, 255, 0)
                _PRINTMODE _KEEPBACKGROUND
                _FONT _LOADFONT("C:\windows\fonts\cour.ttf", 65)
                LOCATE 8, 813: PRINT CHR$(25)
                _FONT _LOADFONT("C:\windows\fonts\cour.ttf", 14)
                _PRINTMODE _FILLBACKGROUND
                'handle down button
            END IF
        NEXT
    END IF
    ' DO
    CALL clicker
    IF click = 1 THEN 'left mouse button must be pressed to check where it was pushed at

        'if mouse clicked in arrow area, and if arrow area is valid:
        IF _MOUSEX > 818 AND _MOUSEX < 838 THEN 'mouse must be in the correct left-right area
            IF _MOUSEY > 210 AND _MOUSEY < 260 THEN
                IF uptrue THEN picon = picon - 9: picchange = -1 'upclick
            ELSEIF _MOUSEY > 270 AND _MOUSEY < 460 THEN
                goahead = 0: EXIT DO
            ELSEIF _MOUSEY > 470 AND _MOUSEY < 520 THEN
                IF downtrue THEN picchange = -1: picon = picon + 9 'down click
            END IF
        END IF

        'if mouse clicked in picture area, and picture is valid:
        FOR i = 1 TO 9
            IF _MOUSEX > x1(i) AND _MOUSEX < x2(i) AND _MOUSEY > y1(i) AND _MOUSEY < y2(i) AND pictrue(i) THEN a$ = pic$(i): EXIT DO
        NEXT
    END IF

    CLOSE
    aa$ = INKEY$
    IF aa$ = CHR$(27) OR rightclick THEN: goahead = 0: EXIT DO 'exit loop without changing the picture

LOOP
CLOSE
IF goahead THEN
    OPEN file$ FOR OUTPUT AS #1
    PRINT #1, frame, a$
    CLOSE #1
    picfile$ = a$
    _FONT _LOADFONT("C:\windows\fonts\cour.ttf", 20)
END IF
changepic = 1
END SUB

FUNCTION Exist% (filename$)
f% = FREEFILE
OPEN filename$ FOR APPEND AS #f%
IF LOF(f%) THEN Exist% = -1 ELSE Exist% = 0: CLOSE #f%: KILL filename$
CLOSE #f%
END FUNCTION

SUB helpfile
DIM bg(900000)
GET (400, 200)-(880, 520), bg()

helppageon = 1: helppagemax = 12
pagechange = 1

DO
    IF pagechange = 1 THEN
        pagechange = 0
        CALL button(400, 200, 800, 520, "", 0, 0, 0, 10)
        CALL button(670, 485, 770, 515, " RETURN", 255, 0, 255, 6)
        _PRINTMODE _FILLBACKGROUND
        COLOR _RGB(255, 255, 255), _RGB(0, 0, 0)

        OPEN "help.txt" FOR INPUT AS #1
        FOR j = 1 TO helppageon
            FOR i = 0 TO 13
                LINE INPUT #1, text$
                IF j = helppageon AND i > 0 THEN _PRINTSTRING (410, 195 + 20 * i), text$
            NEXT
        NEXT
        CLOSE
        IF helppageon > 1 THEN CALL button(430, 485, 530, 515, "  BACK", 255, 0, 255, 6)
        IF helppageon < helppagemax THEN CALL button(550, 485, 650, 515, "  NEXT", 255, 0, 255, 6)
    END IF
    CALL clicker
    IF click = 1 THEN 'left mouse button must be pressed to check where it was pushed at
        IF _MOUSEY > 485 AND _MOUSEY < 515 THEN
            pagechange = 1
            SELECT CASE _MOUSEX
                CASE 430 TO 530
                    IF helppageon > 1 THEN helppageon = helppageon - 1
                CASE 550 TO 650
                    IF helppageon < helppagemax THEN helppageon = helppageon + 1
                CASE 670 TO 770: EXIT DO
            END SELECT
        END IF
    END IF

    a$ = INKEY$
    IF a$ = CHR$(27) OR rightclick THEN EXIT DO
LOOP
PUT (400, 200), bg(), PSET
click = 0: rightclick = 0
END SUB


SUB clicker
click = 0: rightclick = 0
DO WHILE _MOUSEINPUT 'check mouse status
    buttondown = _MOUSEBUTTON(1): rightbuttondown = _MOUSEBUTTON(2)
LOOP
DO WHILE buttondown 'check for button release
    i = _MOUSEINPUT
    buttondown = _MOUSEBUTTON(1)
    click = 1
LOOP
DO WHILE rightbuttondown 'check for button release
    i = _MOUSEINPUT
    rightbuttondown = _MOUSEBUTTON(2)
    rightclick = 1
LOOP

END SUB

SUB highscores
DIM bg(900000), file$(4)
GET (400, 200)-(950, 520), bg()

pageon = 1: pagechange = 1
file$(1) = "trivial.hs": file$(2) = "easy.hs"
file$(3) = "hard.hs": file$(4) = "insane.hs"
_FONT _LOADFONT("C:\windows\fonts\cour.ttf", 16, "BOLD")

DO
    IF pagechange = 1 THEN
        pagechange = 0
        CALL button(400, 200, 950, 520, "", 0, 0, 0, 10)
        CALL button(430, 485, 520, 515, "TRIVIAL", 255, 0, 255, 8)
        CALL button(530, 485, 620, 515, " EASY", 255, 0, 255, 8)
        CALL button(630, 485, 720, 515, " HARD", 255, 0, 255, 8)
        CALL button(730, 485, 820, 515, "INSANE", 255, 0, 255, 8)
        CALL button(830, 485, 920, 515, " EXIT", 255, 0, 255, 8)
        COLOR _RGB(255, 255, 255)
        title$ = UCASE$(LEFT$(file$(pageon), LEN(file$(pageon)) - 3)) + " HIGH SCORES"
        _PRINTSTRING (550, 210), title$
        _PRINTSTRING (420, 240), "RANK"
        _PRINTSTRING (600, 240), "NAME"
        _PRINTSTRING (750, 240), "MOVES"
        _PRINTSTRING (850, 240), "TIME"
        OPEN file$(pageon) FOR INPUT AS #1
        FOR i = 1 TO 10
            INPUT #1, ranking, winner$, c, h, m, s
            IF i < 10 THEN
                t$ = STR$(ranking) + ")          " + winner$
            ELSE
                t$ = STR$(ranking) + ")         " + winner$
            END IF
            _PRINTSTRING (420, 240 + 15 * i), t$
            _PRINTSTRING (760, 240 + 15 * i), STR$(c)
            t$ = STR$(h) + "h" + STR$(m) + "m" + STR$(s) + "s"
            _PRINTSTRING (820, 240 + 15 * i), t$
        NEXT
        CLOSE
    END IF
    CALL clicker

    IF click = 1 THEN 'left mouse button must be pressed to check where it was pushed at
        IF _MOUSEY > 485 AND _MOUSEY < 515 THEN
            pagechange = 1
            SELECT CASE _MOUSEX
                CASE 430 TO 520: pagechange = 1: pageon = 1
                CASE 530 TO 620: pagechange = 1: pageon = 2
                CASE 630 TO 720: pagechange = 1: pageon = 3
                CASE 730 TO 820: pagechange = 1: pageon = 4
                CASE 830 TO 920: EXIT DO
            END SELECT
        END IF
    END IF

    a$ = INKEY$
    IF a$ = CHR$(27) OR rightclick THEN EXIT DO
LOOP
PUT (400, 200), bg(), PSET

END SUB



SUB youwon (z, finishtime!)

DIM bg(900000), file$(4)
GET (400, 200)-(950, 520), bg()
_PRINTMODE _FILLBACKGROUND
COLOR _RGB(255, 255, 255), _RGB(0, 0, 0)
_SNDPLAYFILE "sounds\applause.wav", 1, 1
_SNDPLAYFILE "sounds\woohoo.wav", 1, 1
_SNDPLAYFILE "sounds\you_got_it.wav", 1, 1

file$(1) = "trivial.hs": file$(2) = "easy.hs"
file$(3) = "hard.hs": file$(4) = "insane.hs"
_FONT _LOADFONT("C:\windows\fonts\cour.ttf", 16, "BOLD")

CALL button(400, 200, 950, 520, "", 0, 0, 0, 10)
CALL button(430, 485, 620, 515, "  PLAY AGAIN", 255, 0, 255, 8)
CALL button(730, 485, 920, 515, "      QUIT", 255, 0, 255, 8)
COLOR _RGB(255, 255, 255)
SELECT CASE z
    CASE 1: pageon = 4 'Insane setting
    CASE 2: pageon = 3 ' Hard setting
    CASE 4: pageon = 2 ' Easy setting
    CASE 8: pageon = 1 ' Trivial setting
END SELECT
title$ = UCASE$(LEFT$(file$(pageon), LEN(file$(pageon)) - 3)) + " HIGH SCORES"
_PRINTSTRING (550, 210), title$
_PRINTSTRING (420, 240), "RANK"
_PRINTSTRING (600, 240), "NAME"
_PRINTSTRING (750, 240), "MOVES"
_PRINTSTRING (850, 240), "TIME"
OPEN file$(pageon) FOR INPUT AS #1
highscore = 1: spotwonat = 0: tc = 0: tempchecker = 0
'Dont let player get lucky and cheat by the gameshuffling all the pieces back in place.
FOR i = 1 TO 10
    INPUT #1, ranking, winner$, c, h, m, s
    IF spotwonat = 0 OR tempchecker = 1 THEN 'highscore spot you replace
        IF c = 0 THEN spotwonat = i '0 clicks on the high scoreboard.  Take this spot
        IF c > playermoves THEN spotwonat = i 'player moved less times than on the high scoreboard. Take this spot.
        IF c = playermoves THEN 'set tempchecker so that program will sort by time if number of clicks match.
            spotwonat = i: tempchecker = 1
            tt = h * 3600 + m * 60 + s
            IF tt >= INT(finishtime!) OR tt = 0 THEN tc = tc + 1
        ELSE
            tempchecker = 0 'set tempchecker to stop counting spotcounter
        END IF
    END IF
    IF c <> 0 AND payermoves >= c THEN highscore = 0
    IF i < 10 THEN
        t$ = STR$(ranking) + ")          " + winner$
    ELSE
        t$ = STR$(ranking) + ")         " + winner$
    END IF
    _PRINTSTRING (420, 240 + 15 * i), t$
    _PRINTSTRING (760, 240 + 15 * i), STR$(c)
    t$ = STR$(h) + "h" + STR$(m) + "m" + STR$(s) + "s"
    _PRINTSTRING (820, 240 + 15 * i), t$
NEXT
CLOSE
COLOR _RGB(255, 255, 0), _RGB(0, 0, 0)
IF tc > -1 THEN spotwonat = spotwonat - tc

IF finishtime! <= 3600 THEN
    ph = 0
ELSE
    ph = INT(finishtime! / 3600)
    finishtime! = finishtime! - ph * 3600
END IF
IF finishtime! <= 60 THEN
    pm = 0
ELSE
    pm = INT(finishtime! / 60)
    finishtime! = finishtime! - pm * 60
END IF
ps = INT(finishtime!)


temp$ = "It took you" + STR$(playermoves) + "  moves and" + STR$(ph) + "h" + STR$(pm) + "m" + STR$(ps) + "s to win."
_PRINTSTRING (475, 435), temp$
IF spotwonat > 0 AND spotwonat < 11 AND playermoves > 0 THEN
    _PRINTSTRING (550, 420), "YOU GOT A HIGH SCORE!!"
    COLOR _RGB(255, 255, 255), 0
    LOCATE 30, 420: PRINT "Give me your name =>";
    LOCATE 30, 620, 1
    INPUT playername$
    IF LEN(playername$) > 20 THEN playername$ = LEFT$(playername$, 20)
    OPEN file$(pageon) FOR INPUT AS #1
    OPEN "temp.hs" FOR OUTPUT AS #2
    temp = 0
    FOR i = 1 TO 10
        INPUT #1, ranking, winner$, c, h, m, s
        temp = temp + 1
        IF i = spotwonat THEN
            WRITE #2, temp, playername$, playermoves, ph, pm, ps
            temp = temp + 1
        END IF

        WRITE #2, temp, winner$, c, h, m, s
    NEXT
    CLOSE
    OPEN file$(pageon) FOR OUTPUT AS #1
    OPEN "temp.hs" FOR INPUT AS #2
    FOR i = 1 TO 10
        INPUT #2, ranking, winner$, c, h, m, s
        WRITE #1, ranking, winner$, c, h, m, s
    NEXT
    CLOSE
    CALL button(400, 200, 950, 520, "", 0, 0, 0, 10)
    CALL button(430, 485, 620, 515, "  PLAY AGAIN", 255, 0, 255, 8)
    CALL button(730, 485, 920, 515, "      QUIT", 255, 0, 255, 8)
    COLOR _RGB(255, 255, 255)
    _PRINTSTRING (550, 210), title$
    _PRINTSTRING (420, 240), "RANK"
    _PRINTSTRING (600, 240), "NAME"
    _PRINTSTRING (750, 240), "MOVES"
    _PRINTSTRING (850, 240), "TIME"
    OPEN file$(pageon) FOR INPUT AS #1
    FOR i = 1 TO 10
        INPUT #1, ranking, winner$, c, h, m, s
        IF i < 10 THEN
            t$ = STR$(ranking) + ")          " + winner$
        ELSE
            t$ = STR$(ranking) + ")         " + winner$
        END IF
        _PRINTSTRING (420, 240 + 15 * i), t$
        _PRINTSTRING (760, 240 + 15 * i), STR$(c)
        t$ = STR$(h) + "h" + STR$(m) + "m" + STR$(s) + "s"
        _PRINTSTRING (820, 240 + 15 * i), t$
    NEXT
    CLOSE
    KILL "temp.hs"
ELSE
END IF

click = 0
DO
    CALL clicker

    IF click = 1 THEN 'left mouse button must be pressed to check where it was pushed at
        click = 0
        IF _MOUSEY > 485 AND _MOUSEY < 515 THEN
            SELECT CASE _MOUSEX
                CASE 430 TO 620: EXIT DO
                CASE 730 TO 920: CALL quitbox
            END SELECT
        END IF
    END IF

    a$ = INKEY$
    IF a$ = CHR$(27) OR rightclick THEN EXIT DO
LOOP

END SUB


SUB quitbox
DIM fg(900000)
x1 = 510: y1 = 310: x2 = 770: y2 = 410
GET (x1, y1)-(x2, y2), fg()
CALL button(x1, y1, x2, y2, "", 0, 0, 255, 10)
_PRINTMODE _KEEPBACKGROUND
COLOR _RGB(255, 255, 0)
_PRINTSTRING (x1 + 40, y1 + 10), "Are you certain"
_PRINTSTRING (x1 + 28, y1 + 25), "you want to quit?"

CALL button(x1 + 5, y1 + 50, x1 + 125, y2 - 10, "   YES", 255, 0, 0, 12)
CALL button(x2 - 125, y1 + 50, x2 - 5, y2 - 10, "   NO", 255, 0, 255, 12)
COLOR _RGB(255, 255, 255)
DO
    CALL clicker
    IF click = 1 THEN 'left mouse button must be pressed to check where it was pushed at
        click = 0 'reset clicker
        IF _MOUSEY > y1 + 50 AND _MOUSEY < y2 - 10 THEN 'mouse must be in the correct up-down area
            IF _MOUSEX > x1 + 5 AND _MOUSEX < x1 + 125 THEN SYSTEM
            IF _MOUSEX > x2 - 125 AND _MOUSEX < x2 - 5 THEN EXIT DO
        END IF
    END IF

    a$ = INKEY$
    IF a$ = CHR$(27) OR rightclick THEN EXIT DO
LOOP
PUT (x1, y1), fg(), PSET
_PRINTMODE _FILLBACKGROUND
END SUB



SUB statuscheck (playermoves, starttime!, z, numright)
DIM sb(900000)
x1 = 510: y1 = 310: x2 = 770: y2 = 410
GET (x1, y1)-(x2, y2), sb()
CALL button(x1, y1, x2, y2, "", 0, 0, 255, 10)
_PRINTMODE _KEEPBACKGROUND

COLOR _RGB(255, 255, 0)
IF starttime! < TIMER THEN timenow! = TIMER - starttime! ELSE timenow! = 60 * 60 * 24 - starttime! + TIMER

LOCATE 1, 1: PRINT timenow!, temptime$
temp1$ = "Moves=" + STR$(playermoves) + "  Time =" + temptime$
temp2$ = "Puzzle Completed =" + STR$(numright) + "/" + STR$((16 / z) * (16 / z))
_PRINTSTRING (x1 + 40, y1 + 10), temp1$
_PRINTSTRING (x1 + 28, y1 + 25), temp2$
CALL button(x1 + 5, y1 + 50, x1 + 125, y2 - 10, "QUIT", 255, 0, 0, 12)
CALL button(x2 - 125, y1 + 50, x2 - 5, y2 - 10, "RETURN", 255, 0, 255, 12)
COLOR _RGB(255, 255, 255), _RGB(0, 0, 255)
DO
    IF starttime! < TIMER THEN timenow! = TIMER - starttime! ELSE timenow! = 60 * 60 * 24 - starttime! + TIMER
    SELECT CASE timenow!
        CASE IS < 60
            s = INT(timenow!)
            temptime$ = STR$(s)
        CASE IS < 3600
            m = INT(timenow! / 60)
            s = INT(timenow! - m * 60)
            IF s > 9 THEN
                temptime$ = STR$(m) + ":" + LTRIM$(STR$(s))
            ELSE
                temptime$ = STR$(m) + ":0" + LTRIM$(STR$(s))
            END IF
        CASE ELSE
            h = INT(timenow! / 3600)
            temptime$ = STR$(h)
            m = INT((timenow! - h * 3600) / 60)
            IF m > 9 THEN
                temptime$ = temptime$ + ":" + LTRIM$(STR$(m))
            ELSE
                temptime$ = temptime$ + ":" + LTRIM$(STR$(m))
            END IF
            s = INT(timenow! - h * 3600 - m * 60)
            IF s > 9 THEN
                temptime$ = temptime$ + ":" + LTRIM$(STR$(s))
            ELSE
                temptime$ = temptime$ + ":" + LTRIM$(STR$(s))
            END IF
    END SELECT

    temp1$ = "Moves=" + STR$(playermoves) + "  Time =" + temptime$


    _PRINTSTRING (x1 + 40, y1 + 10), temp1$

    CALL clicker
    IF click = 1 THEN 'left mouse button must be pressed to check where it was pushed at
        click = 0 'reset clicker
        IF _MOUSEY > y1 + 50 AND _MOUSEY < y2 - 10 THEN 'mouse must be in the correct up-down area
            IF _MOUSEX > x1 + 5 AND _MOUSEX < x1 + 125 THEN SYSTEM
        END IF
        IF _MOUSEX > x2 - 125 AND _MOUSEX < x2 - 5 THEN EXIT DO
    END IF

    a$ = INKEY$
    IF a$ = CHR$(32) OR rightclick THEN EXIT DO
    IF a$ = CHR$(27) THEN CALL quitbox
LOOP
PUT (x1, y1), sb(), PSET
_PRINTMODE _FILLBACKGROUND

END SUB

